- name: "Wait for Keycloak to come up"
  uri:
    url: "https://idm.{{ DOMAIN }}/auth"
    status_code: 200
  register: result
  until: result.status == 200
  retries: 80
  delay: 10
  
- name: Get Admin credentials
  kubernetes.core.k8s_info:
    kubeconfig: '{{ k8s_config }}'
    kind: Secret
    namespace: '{{ k8s_namespace }}'
    name: '{{ inv_idm.keycloak.k8s_secret_name }}'
  register: admin_credentials

- name: Store IDM Credentials
  set_fact:
    ADMIN_USERNAME: "{{ admin_credentials.resources[0].data.MASTER_USERNAME | b64decode }}"
    ADMIN_PASSWORD: "{{ admin_credentials.resources[0].data.MASTER_PASSWORD | b64decode }}"
    cacheable: yes

- name: Keycloak Login and get token
  uri:
    method: POST
    url: "https://idm.{{ DOMAIN }}/auth/realms/master/protocol/openid-connect/token"
    return_content: yes
    body_format: form-urlencoded
    body:
        grant_type: "password"
        client_id: "admin-cli"
        username: "{{ ADMIN_USERNAME }}"
        password: "{{ ADMIN_PASSWORD }}"
    status_code: 200
  register: keycloak_login

- name: Get users
  uri:
    method: GET
    url: "https://idm.{{ DOMAIN }}/auth/admin/realms/master/users"
    return_content: yes
    headers:
      Accept: application/json
      Authorization: Bearer {{ keycloak_login.json.access_token }}
    status_code: 200
  register: users

- name: Check if already existing.
  debug:
    var: users

- name: "Set user id."
  set_fact:
    master_admin_id: "{{ users.json | json_query(query) }}"
  vars:
    query: "[?username== '{{ ADMIN_USERNAME }}'].id | [0]"

- name: Check if already existing.
  debug:
    var: master_admin_id

- name: "Update master-realm admin user email"
  uri:
    method: PUT
    url: "https://idm.{{ DOMAIN }}/auth/admin/realms/master/users/{{ master_admin_id }}"
    return_content: yes
    body_format: json
    body: |
        {
          "email":"admin@{{ DOMAIN }}"
        }
    headers:
      Accept: application/json
      Authorization: Bearer {{ keycloak_login.json.access_token }}
    status_code: 204
